"use strict";
{
    globalThis.C3.Plugins.EMI_INDO_Ultimate_Camera.Acts = {
        Optimis(x, y, width, height) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const ops = {
                x: x,
                y: y,
                width: width,
                height: height,
                camera: CameraPreview.CAMERA_DIRECTION.BACK,
                tapPhoto: self.tapphoto,
                previewDrag: self.previewdrag,
                toBack: self.toback,
                tapFocus: self.tapfocus,
                storeToFile: self.storetofile,
                disableExifHeaderStripping: self.disableexifheader

            };

            this.EMI_INDO.startCamera(ops, success, fail);

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Camera);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Error);
            }


        },

        Putar() {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            this.EMI_INDO.switchCamera(success, fail);

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Putar);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Error);

            }

        },

        Stopcamera() {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            this.EMI_INDO.stopCamera(success, fail);

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Stop);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Error);
            }


        },

        Show() {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            this.EMI_INDO.show(success, fail);

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Show);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Error);
            }


        },

        Hide() {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            this.EMI_INDO.hide(success, fail);

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Hide);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Error);
            }


        },

        Takepicture(a, b, c, d) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            var imageData = {

                width: a,
                height: b,
                quality: c,
                filepath: d

            };

            function success(imageData) {

                self.eventResponse = (imageData);
                self._trigger(self.ins.Takepicture);
            }

            function fail(result) {
                self.errorResponse = (result);
                self._trigger(self.ins.Error);

            }

            this.EMI_INDO.takePicture(success, fail, function (imageData) {

            });



        },

        Takesnapshot(quality) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            function success(result) {

                self.eventResponse = (result);
                self._trigger(self.ins.Takesnapshot);
            }

            function fail(result) {
                self.errorResponse = (result);
                self._trigger(self.ins.Error);
            }

            this.EMI_INDO.takeSnapshot(
                {
                    quality: quality
                }, success, fail, function (base64PictureData) {

            });
        },

        Setcoloreffect(eff) {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            this.EMI_INDO.setColorEffect(CameraPreview.COLOR_EFFECT = eff, success, fail);
        },

        Setflashmode(rh) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }
            this.EMI_INDO.setFlashMode(CameraPreview.FLASH_MODE = rh, success, fail);

        },

        Startrecordvideo(p, w, x, y, fp) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            var opt = {
                cameraDirection: CameraPreview.CAMERA_DIRECTION.BACK,
                width: p,
                height: w,
                quality: x,
                withFlash: y
            }

            this.EMI_INDO.startRecordVideo(opt, success, fail, function (fp) {

            });

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Startrecordvideo);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

        },

        Stoprecordvideo(filePath) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }


            this.EMI_INDO.stopRecordVideo(success, fail, function (filePath) {

            });

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Stoprecordvideo);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

        },

        Setpreviewsize(w, h) {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.setPreviewSize(
                {
                    width: w,
                    height: h,
                    success,
                    fail
                });

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }
        },

        Setzoom(zom) {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.setZoom(zom, success, fail);


            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

        },

        Costum(x, y, width, height, camerax, toBack, tapPhoto, tapFocus, previewDrag, storeToFile, disableExifHeaderStripping) {
            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }
            else {
                const ops = {
                    x: x,
                    y: y,
                    width: width,
                    height: height,
                    camera: CameraPreview.CAMERA_DIRECTION = camerax,
                    tapPhoto: tapPhoto,
                    previewDrag: previewDrag,
                    toBack: toBack,
                    tapFocus: tapFocus,
                    previewDrag: previewDrag,
                    storeToFile: storeToFile,
                    disableExifHeaderStripping: disableExifHeaderStripping,
                    backgroundcolor: 'transparent'

                };

                this.EMI_INDO.startCamera(ops, success, fail);

                function success(result) {
                    self.eventResponse = (result);
                    self._trigger(self.ins.Camera);
                }

                function fail(result) {
                    self.eventResponse = (result);
                    self._trigger(self.ins.Error);
                }

            }
        },

        Setwhitebalancemode(wbm) {

            const self = this;
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }


            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            this.EMI_INDO.setWhiteBalanceMode(CameraPreview.WHITE_BALANCE_MODE = wbm, success, fail);
        },

        Taptofocus(x, y) {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            let xPoint = event = x;
            let yPoint = event = y
            this.EMI_INDO.tapToFocus(xPoint, yPoint, success, fail);


            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

        },

        Setexposuremode(exp) {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.setExposureMode(CameraPreview.EXPOSURE_MODE = exp, success, fail);

            function success(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

            function fail(result) {
                self.eventResponse = (result);
                self._trigger(self.ins.Response);
            }

        },

        Getsupportedfocusmodes() {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.getSupportedFocusModes(function (focusModes) {
                focusModes.forEach(function (focusMode) {
                    self.eventResponse = (focusMode + ', ');
                    self._trigger(self.ins.Response);
                });
            });
        },

        Getfocusmode() {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.getFocusMode(function (currentFocusMode) {
                self.eventResponse = (currentFocusMode);
                self._trigger(self.ins.Response);
            });
        },

        Getsupportedflashmodes() {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.getSupportedFlashModes(function (flashModes) {
                flashModes.forEach(function (flashMode) {
                    self.eventResponse = (flashMode + ', ');
                    self._trigger(self.ins.Response);
                });
            });
        },

        Getflashmode() {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.getFlashMode(function (currentFlashMode) {
                self.eventResponse = (currentFlashMode);
                self._trigger(self.ins.Response);
            });
        },

        Gethorizontalfov() {
            if (typeof window['CameraPreview'] == 'undefined') {
                return;
            }

            const self = this;
            this.EMI_INDO.getHorizontalFOV(function (getHorizontalFOV) {
                self.eventResponse = (getHorizontalFOV);
                self._trigger(self.ins.Response);
            });
        }
    };
}